RUSTSEC-2024-0002: Unsoundness in vmm-sys-util

Rust Crates.io Security Advisory


History
Edit
JSON (OSV)

RUSTSEC-2024-0002

serde deserialization for FamStructWrapper lacks bound checks that could potentially lead to out-of-bounds memory access


Reported
Issued

Package

vmm-sys-util
(crates.io)

Type

INFO
Unsound

Categories
Aliases
References
CVSS Score
5.7
MEDIUM
CVSS Details
Attack vector
Local
Attack complexity
Low

Privileges required
None
User interaction
None
Scope
Changed
Confidentiality
None
Integrity
Low
Availability
Low
CVSS Vector
CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:L
Patched
  • >=0.12.0
Unaffected
  • <0.5.0
Affected Functions
Version
vmm_sys_util::fam::FamStructWrapper::deserialize
  • <0.12.0, >=0.5.0

Description

Impact

An issue was discovered in the FamStructWrapper::deserialize implementation
provided by the crate for vmm_sys_util::fam::FamStructWrapper, which can lead
to out of bounds memory accesses. The deserialization does not check that the
length stored in the header matches the flexible array length. Mismatch in the
lengths might allow out of bounds memory access through Rust-safe methods.

Impacted versions: >= 0.5.0

Patches

The issue was corrected in version 0.12.0 by inserting a check that verifies
the lengths of compared flexible arrays are equal for any deserialized header
and aborting deserialization otherwise. Moreover, the API was changed so that
header length can only be modified through Rust-unsafe code. This ensures that
users cannot trigger out-of-bounds memory access from Rust-safe code.

Advisory available under CC0-1.0
license.

READ MORE